CREATE TABLE if not exists [contactgroups] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [name_short] varchar(255) NOT NULL, [name] varchar(255) NOT NULL, [view_only] tinyint(1) NOT NULL DEFAULT ('0'), [timeframe_id] int(11) NOT NULL DEFAULT ('0'), [timezone_id] int(11) NOT NULL DEFAULT ('372'));
CREATE UNIQUE INDEX [idx_contactgroups_names] ON [contactgroups] ([name], [name_short]);
CREATE TABLE if not exists `contactgroups_to_contacts` (  `contactgroup_id` int(11) NOT NULL,  `contact_id` int(11) NOT NULL);
CREATE TABLE if not exists [contacts] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [admin] tinyint(1) DEFAULT ('0'), [username] varchar(255) NOT NULL, [full_name] varchar(255) NOT NULL, [email] varchar(255), [phone] varchar(255), [mobile] varchar(255), [section] varchar(255), [growladdress] varchar(255), [password] varchar(255), [timeframe_id] int(11) NOT NULL DEFAULT ('0'), [timezone_id] int(11) NOT NULL DEFAULT ('372'), [restrict_alerts] tinyint(1));
CREATE UNIQUE INDEX [idx_contacts_username] ON [contacts] ([username]);
CREATE TABLE if not exists [escalations_contacts] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [notification_id] int(11) NOT NULL, [on_ok] tinyint(1) NOT NULL, [on_warning] tinyint(1) NOT NULL, [on_critical] tinyint(1) NOT NULL, [on_unknown] tinyint(1) NOT NULL, [on_host_up] tinyint(1) NOT NULL, [on_host_unreachable] tinyint(1) NOT NULL, [on_host_down] tinyint(1) NOT NULL, [on_type_problem] tinyint(1) NOT NULL, [on_type_recovery] tinyint(1) NOT NULL, [on_type_flappingstart] tinyint(1) NOT NULL, [on_type_flappingstop] tinyint(1) NOT NULL, [on_type_flappingdisabled] tinyint(1) NOT NULL, [on_type_downtimestart] tinyint(1) NOT NULL, [on_type_downtimeend] tinyint(1) NOT NULL, [on_type_downtimecancelled] tinyint(1) NOT NULL, [on_type_acknowledgement] tinyint(1) NOT NULL, [on_type_custom] tinyint(1) NOT NULL, [notify_after_tries] varchar(255) DEFAULT ('0'));
CREATE INDEX [idx_escalations_contacts_notification_id] ON [escalations_contacts] ([notification_id]);
CREATE TABLE if not exists [escalations_contacts_to_contactgroups] (  [escalation_contacts_id] int(11) NOT NULL, [contactgroup_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([escalation_contacts_id], [contactgroup_id]));
CREATE TABLE if not exists [escalations_contacts_to_contacts] (  [escalation_contacts_id] int(11) NOT NULL, [contacts_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([escalation_contacts_id], [contacts_id]));
CREATE TABLE if not exists [escalations_contacts_to_methods] (  [escalation_contacts_id] int(11) NOT NULL, [method_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([escalation_contacts_id], [method_id]));
CREATE TABLE if not exists [escalation_stati] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [notification_rule] int(11), [starttime] int(11) NOT NULL, [counter] int(11) NOT NULL, [incident_id] bigint(20) NOT NULL, [recipients] varchar(255), [host] varchar(255) NOT NULL, [host_alias] varchar(255), [host_address] varchar(255), [hostgroups] varchar(255), [service] varchar(255), [servicegroups] varchar(255), [check_type] varchar(255) NOT NULL, [status] varchar(255) NOT NULL, [time_string] varchar(255), [type] varchar(255), [authors] varchar(255), [comments] varchar(255), [output] varchar(4096));
CREATE INDEX [idx_escalation_stati_incident_id] ON [escalation_stati] ([incident_id]);
CREATE TABLE if not exists [holidays] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [holiday_name] varchar(255), [timeframe_id] int(11), [contact_id] int(11), [holiday_start] datetime NOT NULL, [holiday_end] datetime NOT NULL);
CREATE INDEX [idx_holidays_contact_id] ON [holidays] ([id], [contact_id]);
CREATE INDEX [idx_holidays_timeframe_id] ON [holidays] ([id], [timeframe_id]);
CREATE TABLE if not exists [information] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [type] varchar(20) NOT NULL, [content] varchar(20) NOT NULL);
CREATE TABLE if not exists [notifications] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [notification_name] varchar(40), [notification_description] varchar(1024), [active] tinyint(1) NOT NULL, [username] varchar(255) NOT NULL, [recipients_include] varchar(255) NULL, [recipients_exclude] varchar(255) NULL, [hosts_include] varchar(255) NULL, [hosts_exclude] varchar(255) NULL, [hostgroups_include] varchar(255) NULL, [hostgroups_exclude] varchar(255) NULL, [services_include] varchar(255) NULL, [services_exclude] varchar(255) NULL, [servicegroups_include] varchar(255) NULL, [servicegroups_exclude] varchar(255) NULL, [notify_after_tries] varchar(10) DEFAULT ('0'), [let_notifier_handle] tinyint(1) DEFAULT ('0'), [rollover] tinyint(1) DEFAULT ('0'), [reloop_delay] int(11) DEFAULT ('0'), [on_ok] tinyint(1) DEFAULT ('0'), [on_warning] tinyint(1) DEFAULT ('0'), [on_unknown] tinyint(1) DEFAULT ('0'), [on_host_unreachable] tinyint(1) DEFAULT ('0'), [on_critical] tinyint(1) DEFAULT ('0'), [on_host_up] tinyint(1) DEFAULT ('0'), [on_host_down] tinyint(1) DEFAULT ('0'), [on_type_problem] tinyint(1) DEFAULT ('0'), [on_type_recovery] tinyint(1) DEFAULT ('0'), [on_type_flappingstart] tinyint(1) DEFAULT ('0'), [on_type_flappingstop] tinyint(1) DEFAULT ('0'), [on_type_flappingdisabled] tinyint(1) DEFAULT ('0'), [on_type_downtimestart] tinyint(1) DEFAULT ('0'), [on_type_downtimeend] tinyint(1) DEFAULT ('0'), [on_type_downtimecancelled] tinyint(1) DEFAULT ('0'), [on_type_acknowledgement] tinyint(1) DEFAULT ('0'), [on_type_custom] tinyint(1) DEFAULT ('0'), [timezone_id] int(11) NOT NULL DEFAULT ('372'), [timeframe_id] int(11) NOT NULL DEFAULT ('0'));
CREATE INDEX [idx_notifications_time] ON [notifications] ([id], [timezone_id], [timeframe_id]);
CREATE TABLE if not exists [notifications_to_contactgroups] (  [notification_id] int(11) NOT NULL, [contactgroup_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([notification_id], [contactgroup_id]));
CREATE TABLE if not exists [notifications_to_contacts] (  [notification_id] int(11) NOT NULL, [contact_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([notification_id], [contact_id]));
CREATE TABLE if not exists [notifications_to_methods] (  [notification_id] int(11) NOT NULL, [method_id] int(11) NOT NULL, CONSTRAINT [] PRIMARY KEY ([notification_id], [method_id]));
CREATE TABLE if not exists [notification_logs] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [timestamp] datetime NOT NULL, [counter] int(11) NOT NULL, [check_type] varchar(10) NOT NULL, [check_result] varchar(15) NOT NULL, [host] varchar(255) NOT NULL, [service] varchar(255) NOT NULL, [notification_type] varchar(255) NOT NULL, [method] varchar(255) NOT NULL, [user] varchar(255) NOT NULL, [result] varchar(1023) NOT NULL, [unique_id] bigint(20), [incident_id] bigint(20), [notification_rule] int(11), [last_method] int(11));
CREATE TABLE if not exists [notification_methods] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [method] varchar(255) NOT NULL, [command] varchar(255) NOT NULL, [contact_field] varchar(255) NOT NULL, [sender] varchar(255), [on_fail] int(11) NOT NULL, [ack_able] tinyint(1) NOT NULL);
CREATE TABLE if not exists [notification_stati] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [host] varchar(255), [service] varchar(255), [check_type] varchar(10), [check_result] varchar(15), [counter] int(11), [pid] int(11) DEFAULT ('0'));
CREATE TABLE if not exists [timeframes] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [timeframe_name] varchar(60) NOT NULL, [dt_validFrom] datetime NOT NULL, [dt_validTo] datetime NOT NULL, [day_monday_all] tinyint(1) DEFAULT ('0'), [day_monday_1st] tinyint(1) DEFAULT ('0'), [day_monday_2nd] tinyint(1) DEFAULT ('0'), [day_monday_3rd] tinyint(1) DEFAULT ('0'), [day_monday_4th] tinyint(1) DEFAULT ('0'), [day_monday_5th] tinyint(1) DEFAULT ('0'), [day_monday_last] tinyint(1) DEFAULT ('0'), [day_tuesday_all] tinyint(1) DEFAULT ('0'), [day_tuesday_1st] tinyint(1) DEFAULT ('0'), [day_tuesday_2nd] tinyint(1) DEFAULT ('0'), [day_tuesday_3rd] tinyint(1) DEFAULT ('0'), [day_tuesday_4th] tinyint(1) DEFAULT ('0'), [day_tuesday_5th] tinyint(1) DEFAULT ('0'), [day_tuesday_last] tinyint(1) DEFAULT ('0'), [day_wednesday_all] tinyint(1) DEFAULT ('0'), [day_wednesday_1st] tinyint(1) DEFAULT ('0'), [day_wednesday_2nd] tinyint(1) DEFAULT ('0'), [day_wednesday_3rd] tinyint(1) DEFAULT ('0'), [day_wednesday_4th] tinyint(1) DEFAULT ('0'), [day_wednesday_5th] tinyint(1) DEFAULT ('0'), [day_wednesday_last] tinyint(1) DEFAULT ('0'), [day_thursday_all] tinyint(1) DEFAULT ('0'), [day_thursday_1st] tinyint(1) DEFAULT ('0'), [day_thursday_2nd] tinyint(1) DEFAULT ('0'), [day_thursday_3rd] tinyint(1) DEFAULT ('0'), [day_thursday_4th] tinyint(1) DEFAULT ('0'), [day_thursday_5th] tinyint(1) DEFAULT ('0'), [day_thursday_last] tinyint(1) DEFAULT ('0'), [day_friday_all] tinyint(1) DEFAULT ('0'), [day_friday_1st] tinyint(1) DEFAULT ('0'), [day_friday_2nd] tinyint(1) DEFAULT ('0'), [day_friday_3rd] tinyint(1) DEFAULT ('0'), [day_friday_4th] tinyint(1) DEFAULT ('0'), [day_friday_5th] tinyint(1) DEFAULT ('0'), [day_friday_last] tinyint(1) DEFAULT ('0'), [day_saturday_all] tinyint(1) DEFAULT ('0'), [day_saturday_1st] tinyint(1) DEFAULT ('0'), [day_saturday_2nd] tinyint(1) DEFAULT ('0'), [day_saturday_3rd] tinyint(1) DEFAULT ('0'), [day_saturday_4th] tinyint(1) DEFAULT ('0'), [day_saturday_5th] tinyint(1) DEFAULT ('0'), [day_saturday_last] tinyint(1) DEFAULT ('0'), [day_sunday_all] tinyint(1) DEFAULT ('0'), [day_sunday_1st] tinyint(1) DEFAULT ('0'), [day_sunday_2nd] tinyint(1) DEFAULT ('0'), [day_sunday_3rd] tinyint(1) DEFAULT ('0'), [day_sunday_4th] tinyint(1) DEFAULT ('0'), [day_sunday_5th] tinyint(1) DEFAULT ('0'), [day_sunday_last] tinyint(1) DEFAULT ('0'), [time_monday_start] time DEFAULT ('00:00:00'), [time_monday_stop] time DEFAULT ('00:00:00'), [time_monday_invert] tinyint(1) DEFAULT ('0'), [time_tuesday_start] time DEFAULT ('00:00:00'), [time_tuesday_stop] time DEFAULT ('00:00:00'), [time_tuesday_invert] tinyint(1) DEFAULT ('0'), [time_wednesday_start] time DEFAULT ('00:00:00'), [time_wednesday_stop] time DEFAULT ('00:00:00'), [time_wednesday_invert] tinyint(1) DEFAULT ('0'), [time_thursday_start] time DEFAULT ('00:00:00'), [time_thursday_stop] time DEFAULT ('00:00:00'), [time_thursday_invert] tinyint(1) DEFAULT ('0'), [time_friday_start] time DEFAULT ('00:00:00'), [time_friday_stop] time DEFAULT ('00:00:00'), [time_friday_invert] tinyint(1) DEFAULT ('0'), [time_saturday_start] time DEFAULT ('00:00:00'), [time_saturday_stop] time DEFAULT ('00:00:00'), [time_saturday_invert] tinyint(1) DEFAULT ('0'), [time_sunday_start] time DEFAULT ('00:00:00'), [time_sunday_stop] time DEFAULT ('00:00:00'), [time_sunday_invert] tinyint(1) DEFAULT ('0'));
CREATE TABLE if not exists [timezones] (  [id] int(11), [timezone] varchar(255) NOT NULL, [time_diff] tinyint(11) NOT NULL, CONSTRAINT [sqlite_autoindex_timezones_1] PRIMARY KEY ([id]));
CREATE TABLE if not exists [tmp_commands] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [operation] varchar(255), [external_id] bigint(20) NOT NULL, [recipients] varchar(255) NOT NULL, [host] varchar(255), [host_alias] varchar(255), [host_address] varchar(255), [hostgroups] varchar(255) NOT NULL, [service] varchar(255), [servicegroups] varchar(255), [check_type] varchar(255), [status] varchar(255), [stime] int(11) DEFAULT ('0'), [notification_type] varchar(255), [authors] varchar(255), [comments] varchar(255), [output] varchar(4096));
CREATE INDEX [idx_tmp_commands_external_id] ON [tmp_commands] ([id], [external_id]);
CREATE TABLE if not exists [tmp_active] (  [id] INTEGER PRIMARY KEY AUTOINCREMENT, [notify_id] bigint(20), [command_id] int(11) REFERENCES [tmp_commands]([id]) ON DELETE CASCADE, [dest] varchar(255), [from_user] varchar(255), [time_string] varchar(255), [user] varchar(255), [method] varchar(255), [notify_cmd] varchar(255), [retries] int(11) DEFAULT ('0'), [rule] int(11) DEFAULT ('0'), [progress] tinyint(1) DEFAULT ('0'), [esc_flag] tinyint(1) DEFAULT ('0'), [bundled] bigint(20) DEFAULT ('0'), [stime] int(11) DEFAULT ('0'));
CREATE INDEX [idx_tmp_active_command_id] ON [tmp_active] ([id], [notify_id], [command_id]);
